<template lang="pug">
  .fullwidth
    centered(v-show="corpora.edges.length > 0")
      corpus-grid(v-if="corpora.edges.length > 0" :corpora="corpora.edges")
      .empty(v-if="corpora.pageInfo && corpora.pageInfo.hasNextPage")
        z-button(@click="showMore()") {{ $t('show more') }}
    centered.d-flex.flex(v-show="corpora.edges.length == 0")
      //- Empty state when fetching corpora
      .empty(v-if="$apollo.queries.corpora.loading")
        spinner(:text="$t('fetching', { thing: $options.filters.lowercase($tc('corpus', 2)) })")
      //- Empty state when no corpora are found
      .empty(v-else)
        p.empty-title.h5 {{ $t('user no corpus') }}
</template>

<script>
import { mapGetters } from 'vuex'

import Centered from '~/components/sublayouts/Centered.vue'
import CorpusGrid from '~/components/CorpusGrid.vue'
import Spinner from '~/components/Spinner.vue'

import listUserCorporaGql from '~/apollo/queries/listUserCorpora'
import { baseQueryVariables, parseCorpus } from '~/apollo/queryBuilderCorpus'

export default {
  layout: 'default+profileheader',
  components: {
    // layout components:
    Centered,
    CorpusGrid,
    // cosmetic components:
    Spinner
  },
  data() {
    return {
      routeParam: this.$route.params.id.substring(1),
      corpora: {
        edges: []
      }
    }
  },

  head() {
    return {
      title: `${this.getInstanceName} - ${this.name}'s corpora`,
      meta: [
        {
          hid: 'og:image',
          property: 'og:image',
          content: this.profile.avatar
        },
        {
          hid: 'og:description',
          property: 'og:description',
          content: this.displayName
        },
        this.crawlable ? {} : { name: 'robots', content: 'noindex, nofollow' }
      ],
      link: [
        // { rel: 'alternate', href='{{$profile->permalink()}}', type: 'application/activity+json' }
        {
          rel: 'alternate',
          href: `${this.$route.path}.rss`,
          title: `${this.name} on OLKi`,
          type: 'application/rss+xml'
        },
        {
          rel: 'alternate',
          href: `${this.$route.path}.atom`,
          title: `${this.name} on OLKi`,
          type: 'application/atom+xml'
        }
      ]
    }
  },
  computed: {
    ...mapGetters('instance', ['getInstanceName'])
  },
  asyncData({ store, params }) {
    store.commit('users/setCurrentUser', params.id.substring(1))
    return store.dispatch('users/getUserByUsername', params.id.substring(1))
  },
  apollo: {
    corpora: {
      query: listUserCorporaGql,
      fetchPolicy: 'cache-and-network',
      variables() {
        return {
          ...baseQueryVariables,
          username: this.routeParam
        }
      },
      update: data => {
        return {
          ...data.userCorpora,
          edges: data.userCorpora.edges.map(edge => parseCorpus(edge.node))
        }
      }
    }
  },
  methods: {
    showMore() {
      if (!this.corpora.pageInfo.hasNextPage) return

      this.$apollo.queries.corpora.fetchMore({
        variables: {
          ...baseQueryVariables,
          after: this.corpora.pageInfo.endCursor
        },
        // Transform the previous result with new data
        updateQuery: (previousResult, { fetchMoreResult }) => {
          fetchMoreResult.corpora.edges = [
            ...previousResult.corpora.edges,
            ...fetchMoreResult.corpora.edges
          ]
          return fetchMoreResult
        }
      })
    }
  }
}
</script>
